﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.TaskUI;

namespace WGV_IndentedTaskDialog
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Project quarterlyProject = this.ultraCalendarInfo1.Projects.Add("QuartlerlyProject", DateTime.Today);
            quarterlyProject.Key = "projkey1";

            // Create a Summary or Parent Task
            Task requirementsTask = this.ultraCalendarInfo1.Tasks.Add(DateTime.Today, TimeSpan.FromDays(5), "Requirements", "projkey1");

            // Create a child task
            Task budgetTask = requirementsTask.Tasks.Add(DateTime.Today, TimeSpan.FromDays(2), "Budget Analysis");
            // Set Deadline
            budgetTask.Deadline = DateTime.Today.AddDays(3);
            //Assign a Resource for this task
            Owner budgetOwner = this.ultraCalendarInfo1.Owners.Add("BudgetOwner", "Bill Isacky");
            budgetTask.Resources.Add(budgetOwner);

            // Create another child task
            Task teamTask = requirementsTask.Tasks.Add(DateTime.Today.AddDays(3), TimeSpan.FromDays(2), "Team Allocation");
            // Set a Constraint for this Task
            teamTask.ConstraintDateTime = DateTime.Today.AddDays(4);
            teamTask.Constraint = TaskConstraint.FinishNoLaterThan;

            // Create a Summary or Parent Task
            Task implemetationTask = this.ultraCalendarInfo1.Tasks.Add(DateTime.Now.AddDays(7), TimeSpan.FromDays(3), "Implementation", "projkey1");

            // Create a child task
            Task frontendTask = implemetationTask.Tasks.Add(DateTime.Now.AddDays(7), TimeSpan.FromDays(3), "GUI Design");
            // Set this task as a Milestone
            frontendTask.Milestone = true;
            // Set Percent Complete for this Task
            frontendTask.PercentComplete = 40;
            frontendTask.Dependencies.Add(budgetTask, TaskDependencyType.StartToStart);
            frontendTask.Dependencies.Add(teamTask, TaskDependencyType.FinishToStart);

            this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
            // Assign the new Project to GanttView so that this Project is shown in GanttView and not the unassigned Project.
            this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[1];

        }

        private void ultraGanttView1_TaskDialogDisplaying(object sender, Infragistics.Win.UltraWinGanttView.TaskDialogDisplayingEventArgs e)
        {

            try
            {
                TaskDialog infragisticsDialog = null;
                if (e.Task.Parent != null)
                {
                    infragisticsDialog = new TaskDialog(e.Task,
                       e.Task.Parent.Tasks, ultraGanttView1);
                }
                else
                {
                   infragisticsDialog = new TaskDialog(e.Task,
                       e.Task.Parent.Tasks, ultraGanttView1);
                }

                infragisticsDialog.ShowDialog();
            }
            catch (Exception ex)
            {
                Debug.WriteLine("");
                Debug.WriteLine(ex.GetType().Name);
                Debug.WriteLine(ex.Message);
            }
            finally
            {
                e.Cancel = true;
            }

        }



    }
}
